#include<stdio.h>
typedef struct ListItem {
    shapes val;
    ListItem* next;
};

class LinkedList{
    ListItem* next;
    public:
        void insert(ListItem*);
        void insert(shapes);
        int size();
        void printout();
        bool is_empty();
        shapes get(int);
        LinkedList();
        ~LinkedList();
    private:
        int count;
};

// insert at the end of the list
void LinkedList::insert(ListItem* item){
    item-> next= next;
    next= item;
    count++;
}

void LinkedList::insert(shapes s){
    ListItem* i;
    i->val= s;
    i->next= next;
    next= i;
    count++;
}

int LinkedList::size(){
    return count;
    //int count= 0;
    //ListItem* curr;
    //curr= next;
    //while(curr){
    //    count++;
    //    curr= curr-> next;
    //}
}

// return element i from the Linked list (i starts at 0-(size-1))
shapes LinkedList::get(int loc){
    ListItem* curr;
    curr= next;
    for (int i= 0; i < loc; i++)
        curr= curr->next;
    return curr->val;
}
void LinkedList::remove(int loc){
    ListItem* curr; 
    curr= next;
    for (int i = 0; i < loc; i++)
        curr= curr->next;
    curr= curr->next->next;
}

void LinkedList::printout(){
    ListItem* curr;
    curr= next;
    while(curr){
        printf("%d\n", curr-> val);
        curr = curr->next;
    }
}
bool LinkedList::is_empty() {
    return (next == NULL);
}
LinkedList::LinkedList(){
    next= NULL;
    count= 0;
}
LinkedList::~LinkedList(){
    while(next){
        ListItem* temp= next;
        //delete next;
        next= temp->next;
    }
}

//* Copyright (C) 1994, Saumyendra Sengupta and Carl P. Korobkin *
//*        and Springer-Verlag Publishing Company                *
//  
//  Code 5.3
//  Program:  slist.c++
//  Purpose:  Object-oriented implementation of a singly linked 
//            list with a simple data of 'char' type.
// 
/*#include <stdio.h>
typedef   int  BOOLEAN;
typedef   char DATA_TYPE;

#include  "bc_list.h"  // For base class
//  Define a singly linked list type class 
//  "LinkedList" with base class "List"
class  LinkedList : public List {
  private:
    typedef struct SLIST_ELEMENT {
       DATA_TYPE      data;
       SLIST_ELEMENT  *next;
    } *LIST_PTR;
    LIST_PTR  head_ptr; // Ptr to first element in list
    void      init_slist() { head_ptr = NULL;};
  protected:
    LIST_PTR  search_element1(LIST_PTR, DATA_TYPE);
    LIST_PTR  search_previous(LIST_PTR, DATA_TYPE);
    LIST_PTR  get_head(void) { return head_ptr; }
    BOOLEAN   is_sublist_empty(LIST_PTR lst_ptr);

  //  Declare the interface routines as "public"
  public:
    LinkedList() { init_slist(); } // Constructor
    ~LinkedList();                 // Destructor 

    BOOLEAN  is_empty() {return (head_ptr == NULL);}
    void     build_list (DATA_TYPE *A);
    void     search_element (DATA_TYPE srch_key);
    void     add_after (DATA_TYPE elt_after,
                        DATA_TYPE new_elt);
    void     delete_element (DATA_TYPE target_key);
    int      get_elt_numbers(void);
    void     print_list(char *hdr);
};

// 
//  ~LinkedList(): 
//    Delete entire singly linked list object and free
//    up its memory spaces (Iterative implementation).
//    This destructor function is implicitly and
//    automatically called by the main() program
//    before the main terminates.
//
LinkedList::~LinkedList(void)
{
    LIST_PTR  next_ptr, // ptr to next elt
                tmp_ptr; 
    tmp_ptr = head_ptr;

    while  (!is_sublist_empty(tmp_ptr)) {
       //  Save pointer to next element    
       next_ptr = tmp_ptr->next;
       delete tmp_ptr;    //  Dispose of its space
       tmp_ptr = next_ptr;
    }
    // Assure 'head_ptr' is not a "dangling pointer"
    head_ptr = NULL; 
}  

BOOLEAN LinkedList::is_sublist_empty(
                            LIST_PTR lst_ptr)
{ 
     return (lst_ptr == NULL); 
} 

// 
//  build_list(): 
//    Build a singly linked list object from a 
//    given string of variable length.                     
//    (Iterative implementation)
//
void LinkedList::build_list(DATA_TYPE *str)
{
    LIST_PTR tmp_ptr, new_ptr;

    while (*str != '\0') {
        new_ptr       =  new SLIST_ELEMENT;
        new_ptr->data =  *str++ ;
        new_ptr->next =  NULL;

        if (head_ptr == NULL) {
           head_ptr = new_ptr;
           tmp_ptr = new_ptr;
        }
        else {
           tmp_ptr->next =  new_ptr;
           tmp_ptr = tmp_ptr->next;
        }
    }
} 

// 
//  search_element1():  
//    Search for an element identified by its key
//    'search_key' (search data) in a list object,
//    pointed to by 'lst_ptr'. Return the pointer 
//    if found; otherwise return NULL. 
//    (Recursive method)
// 
LinkedList::LIST_PTR 
LinkedList::search_element1( 
            LIST_PTR lst_ptr, DATA_TYPE search_key)
{
    if (!is_sublist_empty(lst_ptr)) {  
       if (search_key == lst_ptr->data)
          return (lst_ptr); 
       search_element1 (lst_ptr->next, search_key);
    }
    else {  
      printf("\n search_element: %s \n", 
             "Element is not found in list");
      return (NULL);
    }
}

void LinkedList::search_element(DATA_TYPE search_key)
{
    if (search_element1 (head_ptr, search_key) != NULL)
      printf("\n Element is found %s \n",
             "in singly linked list");
}

//
//  search_previous():
//    Search for an element in a singly linked 
//    list object given its data as key 'search_key',
//    and return a pointer to the previous element
//    (predecessor) if found. Return NULL if the
//    given data element is not found or the first
//    element in the list. (Recursive method)
//
LinkedList::LIST_PTR 
LinkedList::search_previous (LIST_PTR lst_ptr, 
                                 DATA_TYPE search_key)
{
    if (lst_ptr != NULL) {
      if (search_key == lst_ptr->next->data)
        return (lst_ptr);
      search_previous (lst_ptr->next, search_key);
    }
    else {
      printf("\n search_previous: Previous %s \n",
             "element is not found in list");
      return (NULL);
    }
}

//
//  delete_element():
//    Delete an element in a singly linked list 
//    object given its data as the search key.
//
void  LinkedList::delete_element(DATA_TYPE search_key)
{
     LIST_PTR  element_ptr, previous_ptr;

     // Check to see if the given element is the
     // first one in the list object.
     if ((head_ptr != NULL) && 
         (head_ptr->data == search_key)) {
        element_ptr = head_ptr->next;
        delete head_ptr;
        head_ptr = element_ptr;
     }
     if ((element_ptr = search_element1 (head_ptr, search_key)) != NULL) {
        previous_ptr = search_previous (head_ptr, search_key);
        previous_ptr->next = element_ptr->next;
        delete element_ptr;
     }
}

// 
//  get_elt_numbers(): 
//    Get elements in a singly linked list object.
//    (Non-recursive, that is, iterative procedure)
//
int LinkedList::get_elt_numbers(void)
{
    LIST_PTR  tmp_ptr = head_ptr;
    int    element_numbers = 0;

    while (tmp_ptr != NULL) {
        ++element_numbers;
        tmp_ptr = tmp_ptr->next;
    }
    return (element_numbers);
} 

//
//  print_list(): 
//    Print the elements of a singly linked list
//    object starting from head elem to tail.
//
void LinkedList::print_list(char *hdr)
{
    LIST_PTR  tmp_ptr = head_ptr;

    printf("\n List %s is:\n  ", hdr);
    while (tmp_ptr != NULL) {
        printf("%c -> ", tmp_ptr->data);
        tmp_ptr = tmp_ptr->next;
    }
    printf("NULL \n"); 
} */

//
//  main(): 
//    Test driver for OOP IMPLEMENTATION
//    OF SINGLY LINKED LIST
// 
/*void main(void)
{
    LinkedList  slist_obj;
    char   *str = "SNIGDHA";        // Input string   
    
    printf("\n ** OOP IMPLEMENTATION %s \n",
           "OF SINGLY LINKED LIST ** " );
    slist_obj.build_list (str);
    slist_obj.print_list("");
    printf(" %s in this list object is: %d \n",
      "Number of elements", slist_obj.get_elt_numbers());
    slist_obj.delete_element ('D');
    slist_obj.print_list("after deleting \'D\'");
    printf(" %s in this list object is: %d \n",
      "Number of elements", slist_obj.get_elt_numbers());
    delete str;
} 
*/
